#include <reg552.h>
#include <rtx51.h>
#include <stdlib.h>
#include <stdio.h>
#include <dsw.h>

#define ADCS 0x08
#define ADCI 0x10
#define ADEX 0x20

#define	ADC			0

extern code unsigned int ADC_Conversion(unsigned char);
extern code unsigned int Conversion(void);

#pragma REGISTERBANK (3)

#define Kanal 0

void Adc(void) _task_ ADC _priority_ 3
{
 int sample;
 signed char RtxCompletion;
 RtxCompletion=os_set_slice(xtal(18.432E6));
 RtxCompletion=os_attach_interrupt(10);
 while(1)
  {
   switch(RtxCompletion=os_wait(K_TMO+K_INT,5,NULL))
    {
		 case	INT_EVENT	:	ADCON^=ADCI; 
											sample=Conversion(); break;
		 case	TMO_EVENT	:	ADCON|=(ADCS+Kanal); break;
		 case	SIG_EVENT	:	break;
		 case	SEM_EVENT	:	break;
		 case	MSG_EVENT	:	break;
	  } 
  }
}

#pragma REGISTERBANK (0)

void main(void)
{
 signed char RtxCompletion;
 RtxCompletion=os_start_system(ADC);
}